'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3 = require('d3');

var d3 = _interopRequireWildcard(_d3);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var margin = {
  top: 20,
  right: 30,
  bottom: 30,
  left: 40
};

var LineChart = (function (_React$PureComponent) {
  _inherits(LineChart, _React$PureComponent);

  function LineChart() {
    var _this = this;

    _classCallCheck(this, LineChart);

    _React$PureComponent.apply(this, arguments);

    this.setSvg = function (svg) {
      if (svg) {
        d3.select(svg).selectAll('g').remove();
        _this.draw(d3.select(svg));
      }
    };

    this.draw = function (svg) {
      var _props = _this.props;
      var data = _props.data;
      var width = _props.width;
      var height = _props.height;

      var x = d3.scaleTime().domain(d3.extent(data, function (d) {
        return d.date;
      })).range([margin.left, width - margin.right]);

      var y = d3.scaleLinear().domain([0, d3.max(data, function (d) {
        return d.value;
      })]).nice().range([height - margin.bottom, margin.top]);

      var xAxis = function xAxis(g) {
        return g.attr('transform', 'translate(0,' + (height - margin.bottom) + ')').call(d3.axisBottom(x).ticks(width / 80).tickSizeOuter(0));
      };

      var yAxis = function yAxis(g) {
        return g.attr('transform', 'translate(' + margin.left + ',0)').call(d3.axisLeft(y)).call(function (g) {
          return g.select('.domain').remove();
        }).call(function (g) {
          return g.select('.tick:last-of-type text').clone().attr('x', 3).attr('text-anchor', 'start').attr('font-weight', 'bold').text(data.y);
        });
      };

      var line = d3.line().defined(function (d) {
        return !isNaN(d.value);
      }).x(function (d) {
        return x(d.date);
      }).y(function (d) {
        return y(d.value);
      });

      svg.append('g').call(xAxis);

      svg.append('g').call(yAxis);

      svg.append('path').datum(data).attr('fill', 'none').attr('stroke', 'steelblue').attr('stroke-width', 1.5).attr('stroke-linejoin', 'round').attr('stroke-linecap', 'round').attr('d', line);
    };
  }

  LineChart.prototype.render = function render() {
    var _props2 = this.props;
    var width = _props2.width;
    var height = _props2.height;

    return _react2['default'].createElement('svg', { ref: this.setSvg, width: width, height: height });
  };

  _createClass(LineChart, null, [{
    key: 'propTypes',
    value: {
      data: _propTypes2['default'].array.isRequired,
      width: _propTypes2['default'].number.isRequired,
      height: _propTypes2['default'].number.isRequired
    },
    enumerable: true
  }]);

  return LineChart;
})(_react2['default'].PureComponent);

exports['default'] = LineChart;
module.exports = exports['default'];