'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3 = require('d3');

var d3 = _interopRequireWildcard(_d3);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TreeMapUtils = require('./TreeMap.utils');

var utils = _interopRequireWildcard(_TreeMapUtils);

var TreeMap = (function (_React$PureComponent) {
  _inherits(TreeMap, _React$PureComponent);

  function TreeMap() {
    var _this = this;

    _classCallCheck(this, TreeMap);

    _React$PureComponent.apply(this, arguments);

    this.state = {
      data: this.props.data
    };

    this.setSvg = function (svg) {
      if (svg) {
        d3.select(svg).selectAll('g').remove();
        _this.draw(svg);
      }
    };

    this.restore = function () {
      _this.setState({
        data: _this.props.data
      });
    };

    this.draw = function (svg) {
      var onClick = _this.props.onClick;

      var cell = d3.select(svg).selectAll('g').data(_this.root).enter().append('g').attr('transform', utils.getTransform);

      cell.append('rect').attr('id', utils.getId).attr('width', utils.getWidth).attr('height', utils.getHeight).attr('fill', utils.setColor);

      cell.append('clipPath').attr('id', utils.getClipId).append('use').attr('xlink:href', utils.getHrefId);

      cell.append('foreignObject').attr('clip-path', utils.getUrlId).attr('width', utils.getWidth).attr('height', utils.getHeight).append('xhtml:div').attr('style', utils.getBlockStyle).append('xhtml:p').html(utils.getName).attr('style', utils.getParagraphStyle).append('xhtml:span').html(utils.getRate);

      cell.append('title').text(utils.getTitle);

      cell.on('click', function (d) {
        if (d.children) {
          _this.setState({
            data: d.data
          });
        } else if (onClick) {
          onClick(d);
        }
      });
    };
  }

  TreeMap.prototype.render = function render() {
    var data = this.state.data;
    var _props = this.props;
    var width = _props.width;
    var height = _props.height;

    return _react2['default'].createElement('svg', { key: data.name, ref: this.setSvg, width: width, height: height });
  };

  _createClass(TreeMap, [{
    key: 'size',
    get: function get() {
      var _props2 = this.props;
      var width = _props2.width;
      var height = _props2.height;

      return [width, height];
    }
  }, {
    key: 'root',
    get: function get() {
      var data = this.state.data;

      var treemap = d3.treemap().tile(d3.treemapBinary).size(this.size).round(true).paddingInner(4).paddingOuter(1);

      var root = d3.hierarchy(data).eachBefore(utils.eachBefore).sum(utils.sumBySize).sort(utils.sort);

      treemap(root);

      var array = root.descendants().reverse();
      return array.splice(0, array.length - 1);
    }
  }], [{
    key: 'propTypes',
    value: {
      data: _propTypes2['default'].object.isRequired,
      width: _propTypes2['default'].number.isRequired,
      height: _propTypes2['default'].number.isRequired,
      onClick: _propTypes2['default'].func
    },
    enumerable: true
  }]);

  return TreeMap;
})(_react2['default'].PureComponent);

exports['default'] = TreeMap;
module.exports = exports['default'];