'use strict';

exports.__esModule = true;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

var _d3 = require('d3');

var d3 = _interopRequireWildcard(_d3);

var format = d3.format(',d');

exports.format = format;
var getTitle = function getTitle(d) {
  return d.data.id + '\n' + format(d.value);
};

exports.getTitle = getTitle;
var getRate = function getRate(d) {
  if (!d.children) {
    return '</br>' + format(d.data.rate) + '%';
  } else {
    return '';
  }
};

exports.getRate = getRate;
var sumBySize = function sumBySize(d) {
  return d.size;
};

exports.sumBySize = sumBySize;
var eachBefore = function eachBefore(d) {
  d.data.id = (d.parent ? d.parent.data.id + '.' : '') + d.data.name;
};

exports.eachBefore = eachBefore;
var sort = function sort(a, b) {
  return b.height - a.height || b.value - a.value;
};

exports.sort = sort;
var getName = function getName(d) {
  return d.data.name;
};

exports.getName = getName;
var getUrlId = function getUrlId(d) {
  return 'url(#clip-' + d.data.id + ')';
};

exports.getUrlId = getUrlId;
var getHrefId = function getHrefId(d) {
  return '#' + d.data.id;
};

exports.getHrefId = getHrefId;
var getClipId = function getClipId(d) {
  return 'clip-' + d.data.id;
};

exports.getClipId = getClipId;
var getId = function getId(d) {
  return d.data.id;
};

exports.getId = getId;
var getTransform = function getTransform(d) {
  return 'translate(' + d.x0 + ',' + d.y0 + ')';
};

exports.getTransform = getTransform;
var getHeight = function getHeight(d) {
  return d.y1 - d.y0;
};

exports.getHeight = getHeight;
var getWidth = function getWidth(d) {
  return d.x1 - d.x0;
};

exports.getWidth = getWidth;
var getBlockStyle = function getBlockStyle(d) {
  if (!d.children) {
    return 'width:' + getWidth(d) + 'px;height:' + getHeight(d) + 'px;\n    display:flex;justify-content:center;align-items:center;font-family:sans-serif;';
  }
  return 'width:' + getWidth(d) + 'px;height:30px;\n  display:flex;justify-content:center;align-items:center;font-family:sans-serif;background:rgba(0,0,0,0.3);';
};

exports.getBlockStyle = getBlockStyle;
var getParagraphStyle = function getParagraphStyle(d) {
  if (!d.children) {
    return 'text-align:center;word-wrap:break-word;max-width:' + getWidth(d) + 'px;';
  }
  return 'text-align:center;word-wrap:break-word;max-width:' + getWidth(d) + 'px;color:black;';
};

exports.getParagraphStyle = getParagraphStyle;
var setColor = function setColor(d) {
  if (d.children) {
    return 'rgba(0,0,0,0.1)';
  }

  return 'rgb(' + (100 + Math.floor(- +d.data.rate * 30)) + ', ' + (100 + Math.floor(+d.data.rate * 30)) + ',\n    ' + Math.floor(- +d.data.rate * 30) + ')';
};
exports.setColor = setColor;